﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Exponentielles_Wachstum
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private void button1_Click(object sender, EventArgs e)
        {

            double W0, Wn, p, n, q;
            if (PosRB.Checked || NegRB.Checked)
            {
                //Weiter mit rechnen
                if (WasCB.SelectedIndex == 0 || WasCB.SelectedIndex == 1 || WasCB.SelectedIndex == 2 || WasCB.SelectedIndex == 3 || WasCB.SelectedIndex == 4)
                {
                    //Weiter mit rechnen
                    switch (WasCB.SelectedIndex)
                    {
                        case 0:
                            //W0
                            if (!double.TryParse(WnWertTB.Text, out Wn) || (!double.TryParse(pWertTB.Text, out p) || (!double.TryParse(nWertTB.Text, out n))))
                            {
                                MessageBox.Show("Entweder fehlt ein Eintrag oder sie haben einen ungültigen Wert eingetragen", "Fehler", 0, MessageBoxIcon.Exclamation);
                                return;
                            }
                            else
                            {
                                if (PosRB.Checked)
                                {
                                    //Egal ob Positiv oder Negativ nur eine konstante Formel funktioniert
                                    W0 = Wn / Math.Pow(1 + p / 100, n);
                                    W0WertTB.Text = W0.ToString();
                                }
                                else
                                {
                                    //Egal ob Positiv oder Negativ nur eine konstante Formel funktioniert
                                    W0 = Wn / Math.Pow(1 + p / 100, n);
                                    W0WertTB.Text = W0.ToString();
                                }
                            }
                            break;
                        case 1:
                            //Wn
                            if (!double.TryParse(W0WertTB.Text, out W0) || (!double.TryParse(pWertTB.Text, out p) || (!double.TryParse(nWertTB.Text, out n))))
                            {
                                MessageBox.Show("Entweder fehlt ein Eintrag oder sie haben einen ungültigen Wert eingetragen!", "Fehler", 0, MessageBoxIcon.Exclamation);
                                return;
                            }
                            else
                            {
                                if (PosRB.Checked)
                                {
                                    Wn = W0 * Math.Pow((1 + (p / 100)), n);
                                    WnWertTB.Text = Wn.ToString();
                                }
                                else
                                {
                                    Wn = W0 * Math.Pow((1 - (p / 100)), n);
                                    WnWertTB.Text = Wn.ToString();
                                }
                            }
                            break;
                        case 2:
                            //p
                            if (!double.TryParse(W0WertTB.Text, out W0) || (!double.TryParse(WnWertTB.Text, out Wn) || (!double.TryParse(nWertTB.Text, out n))))
                            {
                                MessageBox.Show("Entweder fehlt ein Eintrag oder sie haben einen ungültigen Wert eingetragen", "Fehler", 0, MessageBoxIcon.Exclamation);
                                return;
                            }
                            else
                            {
                                if (PosRB.Checked)
                                {
                                    //Egal ob Positiv oder Negativ nur eine konstante Formel funktioniert
                                    q = Math.Pow(Wn / W0, 1 / n);
                                    p = (q - 1) * 100;
                                    pWertTB.Text = p.ToString();
                                }
                                else
                                {
                                    //Egal ob Positiv oder Negativ nur eine konstante Formel funktioniert
                                    q = Math.Pow(Wn / W0, 1 / n);
                                    p = (q - 1) * 100;
                                    pWertTB.Text = p.ToString();
                                }
                            }
                            break;
                        case 3:
                            //n
                            if (!double.TryParse(W0WertTB.Text, out W0) || (!double.TryParse(WnWertTB.Text, out Wn) || (!double.TryParse(qWertTB.Text, out q))))
                            {
                                MessageBox.Show("Entweder fehlt ein Eintrag oder sie haben einen ungültigen Wert eingetragen", "Fehler", 0, MessageBoxIcon.Exclamation);
                                return;
                            }
                            else
                            {
                                if (PosRB.Checked)
                                {
                                    n = Math.Log(Wn / W0) / Math.Log(q);
                                    nWertTB.Text = n.ToString();
                                }
                                else
                                {
                                    n = Math.Log(Wn / W0) / Math.Log(q);
                                    WnWertTB.Text = Wn.ToString();
                                }
                            }
                            break;
                        case 4:
                            //q
                            if (!double.TryParse(W0WertTB.Text, out W0) || (!double.TryParse(WnWertTB.Text, out Wn) || (!double.TryParse(nWertTB.Text, out n))))
                            {
                                MessageBox.Show("Entweder fehlt ein Eintrag oder sie haben einen ungültigen Wert eingetragen.", "Fehler", 0, MessageBoxIcon.Exclamation);
                                return;
                            }
                            else
                            {
                                if (PosRB.Checked)
                                {
                                    q = Math.Pow(Wn / W0, 1 / n);
                                    qWertTB.Text = q.ToString();
                                }
                                else
                                {
                                    q = Math.Pow(Wn / W0, 1 / n);
                                    qWertTB.Text = q.ToString();
                                }
                            }
                            break;
                    }
                }
                else
                {
                    //Ansonsten Fehlermeldung
                    MessageBox.Show("Keine Rechenaktion wurde ausgewählt", "Fehler", 0, MessageBoxIcon.Exclamation);
                    return;
                }
            }
            else
            {
                //Ansonsten Fehlermeldung
                return;
            }
        }
        private void button2_Click(object sender, EventArgs e)
        {
            Close();
        }
        private void button3_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Positives und Negatives Wachstum ist nur zum berechnen den Endwertes nötig. \nWn benötigt: W0, n, p bzw. q \nW0 benötigt: Wn, n, p \np benötigt: q \nq benötigt: Wn, W0, n \nn benötigt: Wn, W0, q \nMit Num 8, Num 2, Num 4 und Num 6 kann die Position des Tools verändert werden. \nWobei der Numlock aktiviert sein muss.", "Hilfe", 0, MessageBoxIcon.Information);
        }
        private void button4_Click(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Minimized;
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            int x, y;
            x = this.Location.X;
            y = this.Location.Y;
            switch (e.KeyCode)
            {
                case Keys.NumPad8:                  
                    this.Location = new Point(x,y -5);
                    break;
                case Keys.NumPad2:                   
                    this.Location = new Point(x,y +5);
                    break;
                case Keys.NumPad4:               
                    this.Location = new Point(x-5, y);
                    break;
                case Keys.NumPad6:
                    this.Location = new Point(x+5, y);
                    break;
            }
        }
    }
}
